<template>
    <view class="container" style="paddingBottom:1rpx;">
      <u-navbar
			leftIconSize="40rpx"
			leftIconColor="#333333"
			title="投资账户记账"
		>
		</u-navbar>
      <view class="section">
        <view class="section-title">{{ title}}</view>
        <view class="form-view">
          <u--form labelPosition="left" :model="form" :rules="rules" ref="uForm" label-width="auto"
            :labelStyle="{ color: '#333333', fontSize: '30rpx' }">
            <u-form-item label="投资账户" prop="inAccountName" required @click="handleFutruesStocks">
              <u--input v-model="form.inAccountName" disabled disabledColor="#ffffff" placeholder="请选择投资账户"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item>
            <u-form-item label="交易类型" prop="dealTypeName" required @click="handleDealType">
              <u--input v-model="form.dealTypeName" disabled disabledColor="#ffffff" placeholder="请选择交易类型"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item> 
            <u-form-item label="转账时间" prop="createTime" required @click="selectDate()">
              <u--input v-model="form.createTime" disabled disabledColor="#ffffff" placeholder="请选择转账时间" inputAlign="right" border="none"></u--input>
						<u-icon slot="right" name="arrow-right"></u-icon>
            </u-form-item>
            <u-form-item label="转账金额" prop="amount" required >
              <u--input v-model="form.amount"  placeholder="请填写转账金额"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
           
            <u-form-item label="备注" prop="remark"  labelPosition="top">
              <u--textarea v-model="form.remark" placeholder="请填写备注" border="none" autoHeight inputAlign="right" count
                maxlength="20000" style="padding:18rpx 0;"></u--textarea>
            </u-form-item>
          </u--form>
          <view class="form-btn">
            <u-button type="primary" text="提交" @click="submit"></u-button>
          </view>
        </view>
      </view>
      <u-toast ref="uToast"></u-toast>
      <u-picker itemHeight="88" :show="showFutruesStocks" :columns="futruesStocksList" keyName="nameDebitNameCode" @cancel="handleFutruesStocksCancel"
        @confirm="handleFutruesStocksConfirm"></u-picker>
        <u-picker itemHeight="88" :show="showDealType" :columns="dealTypeList" keyName="dictLabel" @cancel="handleDealTypeCancel"
        @confirm="handleDealTypeConfirm"></u-picker>
        <u-datetime-picker
			:show="datePickShow"
			mode="datetime"
      ref="createTimeRef" 
			@cancel="datePickShow=false"
			@confirm="datePickConfirm"
			itemHeight="88"
		></u-datetime-picker>
    </view>
  </template>
  
  <script setup>
  import {getAccountsTransferRecord, addAccountsTransferRecord, updateAccountsTransferRecord } from '@/api/invest/accountsTransferRecord'
  import { listFutureStocks } from '@/api/invest/futureStocks'
import { getDicts } from '@/api/system/dict/data.js'
  const { proxy } = getCurrentInstance()
  import dayjs from 'dayjs'
  import {onLoad,onReady} from "@dcloudio/uni-app";
    // 计算属性与监听属性是在vue中而非uniap中 需要注意！！！
import {reactive ,toRefs,ref,computed ,getCurrentInstance }from "vue";
const datePickShow = ref(false)
const showFutruesStocks = ref(false)
const showDealType = ref(false)
const title = ref("投资账户记账")
const futruesStocksList = ref([])
const dealTypeList = ref([])
const data = reactive({
  form: {
    id: null,
    name: null,
    type: '3',
    outAccountId: null,
    inAccountId: null,
    posId: null,
    commission: null,
    amount: null,
    actualAmount: null,
    dealType: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    delFlag: null,
    remark: null
  },
  queryFutruesStocksParams: {
    pageNum: 1,
    pageSize: 1000
  },
  rules: {
    inAccountName: [{ required: true, message: '投资账户不能为空', trigger:['change', 'blur'] }],
    dealTypeName: [{ required: true, message: '交易类型不能为空', trigger: ['change', 'blur'] }],
    amount: [{ required: true, message: '转账金额不能为空', trigger: ['change', 'blur'] }],
    createTime: [{ required: true, message: '转账时间不能为空', trigger: ['change', 'blur'] }]
  }
})
const { form, queryFutruesStocksParams, rules} = toRefs(data)


onLoad((option) => {
       form.value.id = option.id
       if(form.value.id!=null){
        title.value="投资账户记账-修改"
       }else{
        title.value="投资账户记账-新增"
       }
      getData()
  })
  onReady(() => {
       form.value.createTime = dayjs(new Date().getTime()).format("YYYY-MM-DD HH:mm:ss")
  })
  function  getData() {
      listFutureStocks(queryFutruesStocksParams.value).then((response) => {
       futruesStocksList.value = [response.rows] 
       })
           // 类型
           getDicts('in_out').then(res => {
        dealTypeList.value =[res.data] 
      })
      if(form.value.id!=null){
        getAccountsTransferRecord(form.value.id).then(res => {
          form.value = res.data   

           // 交易类型
             getDicts('in_out').then(result => {
              form.value.amount = res.data.amount   
          form.value.dealTypeName=dictStr(form.value.dealType, result.data)
         })
        })
      }
  }

  function handleFutruesStocks() {
        if (futruesStocksList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '投资账户为空  ', type: 'warning'
          })
        } else {
          showFutruesStocks.value = true
        }
     }
  function   handleFutruesStocksConfirm(e) {
       form.value.inAccountName = e.value[0].nameDebitNameCode
        form.value.inAccountId = e.value[0].id
        showFutruesStocks.value = false    
  }
 function handleFutruesStocksCancel() {
       showFutruesStocks.value = false
    }
  function handleDealType() {
        if (dealTypeList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '交易类型为空  ', type: 'warning'
          })
        } else {
          showDealType.value = true
        }
     }
  function   handleDealTypeConfirm(e) {
        form.value.dealTypeName = e.value[0].dictLabel
        form.value.dealType = e.value[0].dictValue
        showDealType.value = false
  }
 function handleDealTypeCancel() {
       showDealType.value = false
      }
      function dictStr(val, arr) {
      let str = ''
      arr.map(item => {
        if (item.dictValue === val) {
          str = item.dictLabel
        }
      })
      return str
    }
  function  selectDate() {
				datePickShow.value = true
        proxy.$refs['createTimeRef'].innerValue = new Date().getTime()
		}
	function datePickConfirm(e) {
				form.value.createTime = dayjs(e.value).format("YYYY-MM-DD HH:mm:ss")
				datePickShow.value = false
		}
  function submit() {
        proxy.$refs['uForm'].validate().then(() => {
          if (form.value.id != null) {
            updateAccountsTransferRecord(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '修改成功', complete() {
                uni.navigateTo({ url: `/pages/work/accounts/investTransferRecord/list` })
              }
            })
          })
          }else {
            addAccountsTransferRecord(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '新增成功', complete() {
                uni.navigateTo({ url: `/pages/work/accounts/investTransferRecord/list` })
              }
            })
          })
          }
        })
      }
  </script>
  
  <style lang="scss" scoped>
  .section {
    margin: 24rpx;
    padding: 16rpx 24rpx;
    background-color: #fff;
    border-radius: 8rpx;
  
    .section-title {
      width: 360rpx;
      color: #333333;
      line-height: 44rpx;
      font-size: 30rpx;
      border-left: 6rpx solid #2681FF;
      padding-left: 26rpx;
    }
  
    .form-view {
      padding: 20rpx 0rpx 0 10rpx;
  
      .form-btn {
        padding-top: 20rpx;
      }
    }
  }
  </style>